# VectorNav C++ Library: UART ASCII Response Packet Parsers

UART ASCII Response Packet Parsers

This group of methods allow parsing of ASCII response data packets from VectorNav's sensors. More...

## Functions

void | vn::protocol::uart::Packet::parseBinaryOutput (uint16_t *asyncMode, uint16_t *rateDivisor, uint16_t *outputGroup, uint16_t *commonField, uint16_t *timeField, uint16_t *imuField, uint16_t *gpsField, uint16_t *attitudeField, uint16_t *insField)
| Parses a response from reading any of the Binary Output registers. More...
void | vn::protocol::uart::Packet::parseUserTag (char *tag)
| Parses a response from reading the User Tag register. More...
void | vn::protocol::uart::Packet::parseModelNumber (char *productName)
| Parses a response from reading the Model Number register. More...
void | vn::protocol::uart::Packet::parseHardwareRevision (uint32_t *revision)
| Parses a response from reading the Hardware Revision register. More...
void | vn::protocol::uart::Packet::parseSerialNumber (uint32_t *serialNum)
| Parses a response from reading the Serial Number register. More...
void | vn::protocol::uart::Packet::parseFirmwareVersion (char *firmwareVersion)
| Parses a response from reading the Firmware Version register. More...
void | vn::protocol::uart::Packet::parseSerialBaudRate (uint32_t *baudrate)
| Parses a response from reading the Serial Baud Rate register. More...
void | vn::protocol::uart::Packet::parseAsyncDataOutputType (uint32_t *ador)
| Parses a response from reading the Async Data Output Type register. More...
void | vn::protocol::uart::Packet::parseAsyncDataOutputFrequency (uint32_t *adof)
| Parses a response from reading the Async Data Output Frequency register. More...
void | vn::protocol::uart::Packet::parseYawPitchRoll (vn::math::vec3f *yawPitchRoll)
| Parses a response from reading the Yaw Pitch Roll register. More...
void | vn::protocol::uart::Packet::parseAttitudeQuaternion (vn::math::vec4f *quat)
| Parses a response from reading the Attitude Quaternion register. More...
void | vn::protocol::uart::Packet::parseQuaternionMagneticAccelerationAndAngularRates (vn::math::vec4f *quat, vn::math::vec3f *mag, vn::math::vec3f *accel, vn::math::vec3f *gyro)
| Parses a response from reading the Quaternion, Magnetic, Acceleration and Angular Rates register. More...
void | vn::protocol::uart::Packet::parseMagneticMeasurements (vn::math::vec3f *mag)
| Parses a response from reading the Magnetic Measurements register. More...
void | vn::protocol::uart::Packet::parseAccelerationMeasurements (vn::math::vec3f *accel)
| Parses a response from reading the Acceleration Measurements register. More...
void | vn::protocol::uart::Packet::parseAngularRateMeasurements (vn::math::vec3f *gyro)
| Parses a response from reading the Angular Rate Measurements register. More...
void | vn::protocol::uart::Packet::parseMagneticAccelerationAndAngularRates (vn::math::vec3f *mag, vn::math::vec3f *accel, vn::math::vec3f *gyro)
| Parses a response from reading the Magnetic, Acceleration and Angular Rates register. More...
void | vn::protocol::uart::Packet::parseMagneticAndGravityReferenceVectors (vn::math::vec3f *magRef, vn::math::vec3f *accRef)
| Parses a response from reading the Magnetic and Gravity Reference Vectors register. More...
void | vn::protocol::uart::Packet::parseFilterMeasurementsVarianceParameters (float *angularWalkVariance, vn::math::vec3f *angularRateVariance, vn::math::vec3f *magneticVariance, vn::math::vec3f *accelerationVariance)
| Parses a response from reading the Filter Measurements Variance Parameters register. More...
void | vn::protocol::uart::Packet::parseMagnetometerCompensation (vn::math::mat3f *c, vn::math::vec3f *b)
| Parses a response from reading the Magnetometer Compensation register. More...
void | vn::protocol::uart::Packet::parseFilterActiveTuningParameters (float *magneticDisturbanceGain, float *accelerationDisturbanceGain, float *magneticDisturbanceMemory, float *accelerationDisturbanceMemory)
| Parses a response from reading the Filter Active Tuning Parameters register. More...
void | vn::protocol::uart::Packet::parseAccelerationCompensation (vn::math::mat3f *c, vn::math::vec3f *b)
| Parses a response from reading the Acceleration Compensation register. More...
void | vn::protocol::uart::Packet::parseReferenceFrameRotation (vn::math::mat3f *c)
| Parses a response from reading the Reference Frame Rotation register. More...
void | vn::protocol::uart::Packet::parseYawPitchRollMagneticAccelerationAndAngularRates (vn::math::vec3f *yawPitchRoll, vn::math::vec3f *mag, vn::math::vec3f *accel, vn::math::vec3f *gyro)
| Parses a response from reading the Yaw, Pitch, Roll, Magnetic, Acceleration and Angular Rates register. More...
void | vn::protocol::uart::Packet::parseCommunicationProtocolControl (uint8_t *serialCount, uint8_t *serialStatus, uint8_t *spiCount, uint8_t *spiStatus, uint8_t *serialChecksum, uint8_t *spiChecksum, uint8_t *errorMode)
| Parses a response from reading the Communication Protocol Control register. More...
void | vn::protocol::uart::Packet::parseSynchronizationControl (uint8_t *syncInMode, uint8_t *syncInEdge, uint16_t *syncInSkipFactor, uint8_t *syncOutMode, uint8_t *syncOutPolarity, uint16_t *syncOutSkipFactor, uint32_t *syncOutPulseWidth)
| Parses a response from reading the Synchronization Control register. More...
void | vn::protocol::uart::Packet::parseSynchronizationStatus (uint32_t *syncInCount, uint32_t *syncInTime, uint32_t *syncOutCount)
| Parses a response from reading the Synchronization Status register. More...
void | vn::protocol::uart::Packet::parseFilterBasicControl (uint8_t *magMode, uint8_t *extMagMode, uint8_t *extAccMode, uint8_t *extGyroMode, vn::math::vec3f *gyroLimit)
| Parses a response from reading the Filter Basic Control register. More...
void | vn::protocol::uart::Packet::parseVpeBasicControl (uint8_t *enable, uint8_t *headingMode, uint8_t *filteringMode, uint8_t *tuningMode)
| Parses a response from reading the VPE Basic Control register. More...
void | vn::protocol::uart::Packet::parseVpeMagnetometerBasicTuning (vn::math::vec3f *baseTuning, vn::math::vec3f *adaptiveTuning, vn::math::vec3f *adaptiveFiltering)
| Parses a response from reading the VPE Magnetometer Basic Tuning register. More...
void | vn::protocol::uart::Packet::parseVpeMagnetometerAdvancedTuning (vn::math::vec3f *minFiltering, vn::math::vec3f *maxFiltering, float *maxAdaptRate, float *disturbanceWindow, float *maxTuning)
| Parses a response from reading the VPE Magnetometer Advanced Tuning register. More...
void | vn::protocol::uart::Packet::parseVpeAccelerometerBasicTuning (vn::math::vec3f *baseTuning, vn::math::vec3f *adaptiveTuning, vn::math::vec3f *adaptiveFiltering)
| Parses a response from reading the VPE Accelerometer Basic Tuning register. More...
void | vn::protocol::uart::Packet::parseVpeAccelerometerAdvancedTuning (vn::math::vec3f *minFiltering, vn::math::vec3f *maxFiltering, float *maxAdaptRate, float *disturbanceWindow, float *maxTuning)
| Parses a response from reading the VPE Accelerometer Advanced Tuning register. More...
void | vn::protocol::uart::Packet::parseVpeGyroBasicTuning (vn::math::vec3f *angularWalkVariance, vn::math::vec3f *baseTuning, vn::math::vec3f *adaptiveTuning)
| Parses a response from reading the VPE Gyro Basic Tuning register. More...
void | vn::protocol::uart::Packet::parseFilterStartupGyroBias (vn::math::vec3f *bias)
| Parses a response from reading the Filter Startup Gyro Bias register. More...
void | vn::protocol::uart::Packet::parseMagnetometerCalibrationControl (uint8_t *hsiMode, uint8_t *hsiOutput, uint8_t *convergeRate)
| Parses a response from reading the Magnetometer Calibration Control register. More...
void | vn::protocol::uart::Packet::parseCalculatedMagnetometerCalibration (vn::math::mat3f *c, vn::math::vec3f *b)
| Parses a response from reading the Calculated Magnetometer Calibration register. More...
void | vn::protocol::uart::Packet::parseIndoorHeadingModeControl (float *maxRateError)
| Parses a response from reading the Indoor Heading Mode Control register. More...
void | vn::protocol::uart::Packet::parseVelocityCompensationMeasurement (vn::math::vec3f *velocity)
| Parses a response from reading the Velocity Compensation Measurement register. More...
void | vn::protocol::uart::Packet::parseVelocityCompensationControl (uint8_t *mode, float *velocityTuning, float *rateTuning)
| Parses a response from reading the Velocity Compensation Control register. More...
void | vn::protocol::uart::Packet::parseVelocityCompensationStatus (float *x, float *xDot, vn::math::vec3f *accelOffset, vn::math::vec3f *omega)
| Parses a response from reading the Velocity Compensation Status register. More...
void | vn::protocol::uart::Packet::parseImuMeasurements (vn::math::vec3f *mag, vn::math::vec3f *accel, vn::math::vec3f *gyro, float *temp, float *pressure)
| Parses a response from reading the IMU Measurements register. More...
void | vn::protocol::uart::Packet::parseGpsConfiguration (uint8_t *mode, uint8_t *ppsSource)
| Parses a response from reading the GPS Configuration register. More...
void | vn::protocol::uart::Packet::parseGpsAntennaOffset (vn::math::vec3f *position)
| Parses a response from reading the GPS Antenna Offset register. More...
void | vn::protocol::uart::Packet::parseGpsSolutionLla (double *time, uint16_t *week, uint8_t *gpsFix, uint8_t *numSats, vn::math::vec3d *lla, vn::math::vec3f *nedVel, vn::math::vec3f *nedAcc, float *speedAcc, float *timeAcc)
| Parses a response from reading the GPS Solution - LLA register. More...
void | vn::protocol::uart::Packet::parseGpsSolutionEcef (double *tow, uint16_t *week, uint8_t *gpsFix, uint8_t *numSats, vn::math::vec3d *position, vn::math::vec3f *velocity, vn::math::vec3f *posAcc, float *speedAcc, float *timeAcc)
| Parses a response from reading the GPS Solution - ECEF register. More...
void | vn::protocol::uart::Packet::parseInsSolutionLla (double *time, uint16_t *week, uint16_t *status, vn::math::vec3f *yawPitchRoll, vn::math::vec3d *position, vn::math::vec3f *nedVel, float *attUncertainty, float *posUncertainty, float *velUncertainty)
| Parses a response from reading the INS Solution - LLA register. More...
void | vn::protocol::uart::Packet::parseInsSolutionEcef (double *time, uint16_t *week, uint16_t *status, vn::math::vec3f *yawPitchRoll, vn::math::vec3d *position, vn::math::vec3f *velocity, float *attUncertainty, float *posUncertainty, float *velUncertainty)
| Parses a response from reading the INS Solution - ECEF register. More...
void | vn::protocol::uart::Packet::parseInsBasicConfiguration (uint8_t *scenario, uint8_t *ahrsAiding)
| Parses a response from reading the INS Basic Configuration register. More...
void | vn::protocol::uart::Packet::parseInsBasicConfiguration (uint8_t *scenario, uint8_t *ahrsAiding, uint8_t *estBaseline)
| Parses a response from reading the INS Basic Configuration register. More...
void | vn::protocol::uart::Packet::parseInsAdvancedConfiguration (uint8_t *useMag, uint8_t *usePres, uint8_t *posAtt, uint8_t *velAtt, uint8_t *velBias, uint8_t *useFoam, uint8_t *gpsCovType, uint8_t *velCount, float *velInit, float *moveOrigin, float *gpsTimeout, float *deltaLimitPos, float *deltaLimitVel, float *minPosUncertainty, float *minVelUncertainty)
| Parses a response from reading the INS Advanced Configuration register. More...
void | vn::protocol::uart::Packet::parseInsStateLla (vn::math::vec3f *yawPitchRoll, vn::math::vec3d *position, vn::math::vec3f *velocity, vn::math::vec3f *accel, vn::math::vec3f *angularRate)
| Parses a response from reading the INS State - LLA register. More...
void | vn::protocol::uart::Packet::parseInsStateEcef (vn::math::vec3f *yawPitchRoll, vn::math::vec3d *position, vn::math::vec3f *velocity, vn::math::vec3f *accel, vn::math::vec3f *angularRate)
| Parses a response from reading the INS State - ECEF register. More...
void | vn::protocol::uart::Packet::parseStartupFilterBiasEstimate (vn::math::vec3f *gyroBias, vn::math::vec3f *accelBias, float *pressureBias)
| Parses a response from reading the Startup Filter Bias Estimate register. More...
void | vn::protocol::uart::Packet::parseDeltaThetaAndDeltaVelocity (float *deltaTime, vn::math::vec3f *deltaTheta, vn::math::vec3f *deltaVelocity)
| Parses a response from reading the Delta Theta and Delta Velocity register. More...
void | vn::protocol::uart::Packet::parseDeltaThetaAndDeltaVelocityConfiguration (uint8_t *integrationFrame, uint8_t *gyroCompensation, uint8_t *accelCompensation)
| Parses a response from reading the Delta Theta and Delta Velocity Configuration register. More...
void | vn::protocol::uart::Packet::parseReferenceVectorConfiguration (uint8_t *useMagModel, uint8_t *useGravityModel, uint32_t *recalcThreshold, float *year, vn::math::vec3d *position)
| Parses a response from reading the Reference Vector Configuration register. More...
void | vn::protocol::uart::Packet::parseGyroCompensation (vn::math::mat3f *c, vn::math::vec3f *b)
| Parses a response from reading the Gyro Compensation register. More...
void | vn::protocol::uart::Packet::parseImuFilteringConfiguration (uint16_t *magWindowSize, uint16_t *accelWindowSize, uint16_t *gyroWindowSize, uint16_t *tempWindowSize, uint16_t *presWindowSize, uint8_t *magFilterMode, uint8_t *accelFilterMode, uint8_t *gyroFilterMode, uint8_t *tempFilterMode, uint8_t *presFilterMode)
| Parses a response from reading the IMU Filtering Configuration register. More...
void | vn::protocol::uart::Packet::parseGpsCompassBaseline (vn::math::vec3f *position, vn::math::vec3f *uncertainty)
| Parses a response from reading the GPS Compass Baseline register. More...
void | vn::protocol::uart::Packet::parseGpsCompassEstimatedBaseline (uint8_t *estBaselineUsed, uint16_t *numMeas, vn::math::vec3f *position, vn::math::vec3f *uncertainty)
| Parses a response from reading the GPS Compass Estimated Baseline register. More...
void | vn::protocol::uart::Packet::parseImuRateConfiguration (uint16_t *imuRate, uint16_t *navDivisor, float *filterTargetRate, float *filterMinRate)
| Parses a response from reading the IMU Rate Configuration register. More...
void | vn::protocol::uart::Packet::parseYawPitchRollTrueBodyAccelerationAndAngularRates (vn::math::vec3f *yawPitchRoll, vn::math::vec3f *bodyAccel, vn::math::vec3f *gyro)
| Parses a response from reading the Yaw, Pitch, Roll, True Body Acceleration and Angular Rates register. More...
void | vn::protocol::uart::Packet::parseYawPitchRollTrueInertialAccelerationAndAngularRates (vn::math::vec3f *yawPitchRoll, vn::math::vec3f *inertialAccel, vn::math::vec3f *gyro)
| Parses a response from reading the Yaw, Pitch, Roll, True Inertial Acceleration and Angular Rates register. More...

## Detailed Description

This group of methods allow parsing of ASCII response data packets from VectorNav's sensors.

The units are not specified for the out parameters since these methods do a simple conversion operation from the packet string. Please consult the appropriate user manual for your sensor for details about the units returned by the sensor.

## Function Documentation

void vn::protocol::uart::Packet::parseAccelerationCompensation | ( | vn::math::mat3f * | c,
|  | vn::math::vec3f * | b
| ) |  |

Parses a response from reading the Acceleration Compensation register.

Parameters

  [out] | c | The register's C field.
  [out] | b | The register's B field.

void vn::protocol::uart::Packet::parseAccelerationMeasurements | ( | vn::math::vec3f * | accel | ) |

Parses a response from reading the Acceleration Measurements register.

Parameters

  [out] | accel | The register's Accel field.

void vn::protocol::uart::Packet::parseAngularRateMeasurements | ( | vn::math::vec3f * | gyro | ) |

Parses a response from reading the Angular Rate Measurements register.

Parameters

  [out] | gyro | The register's Gyro field.

void vn::protocol::uart::Packet::parseAsyncDataOutputFrequency | ( | uint32_t * | adof | ) |

Parses a response from reading the Async Data Output Frequency register.

Parameters

  [out] | adof | The register's ADOF field.

Examples:
  uart_protocol/main.cpp.

void vn::protocol::uart::Packet::parseAsyncDataOutputType | ( | uint32_t * | ador | ) |

Parses a response from reading the Async Data Output Type register.

Parameters

  [out] | ador | The register's ADOR field.

void vn::protocol::uart::Packet::parseAttitudeQuaternion | ( | vn::math::vec4f * | quat | ) |

Parses a response from reading the Attitude Quaternion register.

Parameters

  [out] | quat | The register's Quat field.

void vn::protocol::uart::Packet::parseBinaryOutput | ( | uint16_t * | asyncMode,
|  | uint16_t * | rateDivisor,
|  | uint16_t * | outputGroup,
|  | uint16_t * | commonField,
|  | uint16_t * | timeField,
|  | uint16_t * | imuField,
|  | uint16_t * | gpsField,
|  | uint16_t * | attitudeField,
|  | uint16_t * | insField
| ) |  |

Parses a response from reading any of the Binary Output registers.

Parameters

  [out] | asyncMode | The register's AsyncMode field.
  [out] | rateDivisor | The register's RateDivisor field.
  [out] | outputGroup | The register's OutputGroup field.
  [out] | commonField | The set fields of Output Group 1 (Common) if present.
  [out] | timeField | The set fields of Output Group 2 (Time) if present.
  [out] | imuField | The set fields of Output Group 3 (IMU) if present.
  [out] | gpsField | The set fields of Output Group 4 (GPS) if present.
  [out] | attitudeField | The set fields of Output Group 5 (Attitude) if present.
  [out] | insField | The set fields of Output Group 6 (INS) if present.

void vn::protocol::uart::Packet::parseCalculatedMagnetometerCalibration | ( | vn::math::mat3f * | c,
|  | vn::math::vec3f * | b
| ) |  |

Parses a response from reading the Calculated Magnetometer Calibration register.

Parameters

  [out] | c | The register's C field.
  [out] | b | The register's B field.

void vn::protocol::uart::Packet::parseCommunicationProtocolControl | ( | uint8_t * | serialCount,
|  | uint8_t * | serialStatus,
|  | uint8_t * | spiCount,
|  | uint8_t * | spiStatus,
|  | uint8_t * | serialChecksum,
|  | uint8_t * | spiChecksum,
|  | uint8_t * | errorMode
| ) |  |

Parses a response from reading the Communication Protocol Control register.

Parameters

  [out] | serialCount | The register's SerialCount field.
  [out] | serialStatus | The register's SerialStatus field.
  [out] | spiCount | The register's SPICount field.
  [out] | spiStatus | The register's SPIStatus field.
  [out] | serialChecksum | The register's SerialChecksum field.
  [out] | spiChecksum | The register's SPIChecksum field.
  [out] | errorMode | The register's ErrorMode field.

void vn::protocol::uart::Packet::parseDeltaThetaAndDeltaVelocity | ( | float * | deltaTime,
|  | vn::math::vec3f * | deltaTheta,
|  | vn::math::vec3f * | deltaVelocity
| ) |  |

Parses a response from reading the Delta Theta and Delta Velocity register.

Parameters

  [out] | deltaTime | The register's DeltaTime field.
  [out] | deltaTheta | The register's DeltaTheta field.
  [out] | deltaVelocity | The register's DeltaVelocity field.

void vn::protocol::uart::Packet::parseDeltaThetaAndDeltaVelocityConfiguration | ( | uint8_t * | integrationFrame,
|  | uint8_t * | gyroCompensation,
|  | uint8_t * | accelCompensation
| ) |  |

Parses a response from reading the Delta Theta and Delta Velocity Configuration register.

Parameters

  [out] | integrationFrame | The register's IntegrationFrame field.
  [out] | gyroCompensation | The register's GyroCompensation field.
  [out] | accelCompensation | The register's AccelCompensation field.

void vn::protocol::uart::Packet::parseFilterActiveTuningParameters | ( | float * | magneticDisturbanceGain,
|  | float * | accelerationDisturbanceGain,
|  | float * | magneticDisturbanceMemory,
|  | float * | accelerationDisturbanceMemory
| ) |  |

Parses a response from reading the Filter Active Tuning Parameters register.

Parameters

  [out] | magneticDisturbanceGain | The register's Magnetic Disturbance Gain field.
  [out] | accelerationDisturbanceGain | The register's Acceleration Disturbance Gain field.
  [out] | magneticDisturbanceMemory | The register's Magnetic Disturbance Memory field.
  [out] | accelerationDisturbanceMemory | The register's Acceleration Disturbance Memory field.

void vn::protocol::uart::Packet::parseFilterBasicControl | ( | uint8_t * | magMode,
|  | uint8_t * | extMagMode,
|  | uint8_t * | extAccMode,
|  | uint8_t * | extGyroMode,
|  | vn::math::vec3f * | gyroLimit
| ) |  |

Parses a response from reading the Filter Basic Control register.

Parameters

  [out] | magMode | The register's MagMode field.
  [out] | extMagMode | The register's ExtMagMode field.
  [out] | extAccMode | The register's ExtAccMode field.
  [out] | extGyroMode | The register's ExtGyroMode field.
  [out] | gyroLimit | The register's GyroLimit field.

void vn::protocol::uart::Packet::parseFilterMeasurementsVarianceParameters | ( | float * | angularWalkVariance,
|  | vn::math::vec3f * | angularRateVariance,
|  | vn::math::vec3f * | magneticVariance,
|  | vn::math::vec3f * | accelerationVariance
| ) |  |

Parses a response from reading the Filter Measurements Variance Parameters register.

Parameters

  [out] | angularWalkVariance | The register's Angular Walk Variance field.
  [out] | angularRateVariance | The register's Angular Rate Variance field.
  [out] | magneticVariance | The register's Magnetic Variance field.
  [out] | accelerationVariance | The register's Acceleration Variance field.

void vn::protocol::uart::Packet::parseFilterStartupGyroBias | ( | vn::math::vec3f * | bias | ) |

Parses a response from reading the Filter Startup Gyro Bias register.

Parameters

  [out] | bias | The register's Bias field.

void vn::protocol::uart::Packet::parseFirmwareVersion | ( | char * | firmwareVersion | ) |

Parses a response from reading the Firmware Version register.

Parameters

  [out] | firmwareVersion | The register's Firmware Version field.

void vn::protocol::uart::Packet::parseGpsAntennaOffset | ( | vn::math::vec3f * | position | ) |

Parses a response from reading the GPS Antenna Offset register.

Parameters

  [out] | position | The register's Position field.

void vn::protocol::uart::Packet::parseGpsCompassBaseline | ( | vn::math::vec3f * | position,
|  | vn::math::vec3f * | uncertainty
| ) |  |

Parses a response from reading the GPS Compass Baseline register.

Parameters

  [out] | position | The register's Position field.
  [out] | uncertainty | The register's Uncertainty field.

void vn::protocol::uart::Packet::parseGpsCompassEstimatedBaseline | ( | uint8_t * | estBaselineUsed,
|  | uint16_t * | numMeas,
|  | vn::math::vec3f * | position,
|  | vn::math::vec3f * | uncertainty
| ) |  |

Parses a response from reading the GPS Compass Estimated Baseline register.

Parameters

  [out] | estBaselineUsed | The register's EstBaselineUsed field.
  [out] | numMeas | The register's NumMeas field.
  [out] | position | The register's Position field.
  [out] | uncertainty | The register's Uncertainty field.

void vn::protocol::uart::Packet::parseGpsConfiguration | ( | uint8_t * | mode,
|  | uint8_t * | ppsSource
| ) |  |

Parses a response from reading the GPS Configuration register.

Parameters

  [out] | mode | The register's Mode field.
  [out] | ppsSource | The register's PpsSource field.

void vn::protocol::uart::Packet::parseGpsSolutionEcef | ( | double * | tow,
|  | uint16_t * | week,
|  | uint8_t * | gpsFix,
|  | uint8_t * | numSats,
|  | vn::math::vec3d * | position,
|  | vn::math::vec3f * | velocity,
|  | vn::math::vec3f * | posAcc,
|  | float * | speedAcc,
|  | float * | timeAcc
| ) |  |

Parses a response from reading the GPS Solution - ECEF register.

Parameters

  [out] | tow | The register's Tow field.
  [out] | week | The register's Week field.
  [out] | gpsFix | The register's GpsFix field.
  [out] | numSats | The register's NumSats field.
  [out] | position | The register's Position field.
  [out] | velocity | The register's Velocity field.
  [out] | posAcc | The register's PosAcc field.
  [out] | speedAcc | The register's SpeedAcc field.
  [out] | timeAcc | The register's TimeAcc field.

void vn::protocol::uart::Packet::parseGpsSolutionLla | ( | double * | time,
|  | uint16_t * | week,
|  | uint8_t * | gpsFix,
|  | uint8_t * | numSats,
|  | vn::math::vec3d * | lla,
|  | vn::math::vec3f * | nedVel,
|  | vn::math::vec3f * | nedAcc,
|  | float * | speedAcc,
|  | float * | timeAcc
| ) |  |

Parses a response from reading the GPS Solution - LLA register.

Parameters

  [out] | time | The register's Time field.
  [out] | week | The register's Week field.
  [out] | gpsFix | The register's GpsFix field.
  [out] | numSats | The register's NumSats field.
  [out] | lla | The register's Lla field.
  [out] | nedVel | The register's NedVel field.
  [out] | nedAcc | The register's NedAcc field.
  [out] | speedAcc | The register's SpeedAcc field.
  [out] | timeAcc | The register's TimeAcc field.

void vn::protocol::uart::Packet::parseGyroCompensation | ( | vn::math::mat3f * | c,
|  | vn::math::vec3f * | b
| ) |  |

Parses a response from reading the Gyro Compensation register.

Parameters

  [out] | c | The register's C field.
  [out] | b | The register's B field.

void vn::protocol::uart::Packet::parseHardwareRevision | ( | uint32_t * | revision | ) |

Parses a response from reading the Hardware Revision register.

Parameters

  [out] | revision | The register's Revision field.

void vn::protocol::uart::Packet::parseImuFilteringConfiguration | ( | uint16_t * | magWindowSize,
|  | uint16_t * | accelWindowSize,
|  | uint16_t * | gyroWindowSize,
|  | uint16_t * | tempWindowSize,
|  | uint16_t * | presWindowSize,
|  | uint8_t * | magFilterMode,
|  | uint8_t * | accelFilterMode,
|  | uint8_t * | gyroFilterMode,
|  | uint8_t * | tempFilterMode,
|  | uint8_t * | presFilterMode
| ) |  |

Parses a response from reading the IMU Filtering Configuration register.

Parameters

  [out] | magWindowSize | The register's MagWindowSize field.
  [out] | accelWindowSize | The register's AccelWindowSize field.
  [out] | gyroWindowSize | The register's GyroWindowSize field.
  [out] | tempWindowSize | The register's TempWindowSize field.
  [out] | presWindowSize | The register's PresWindowSize field.
  [out] | magFilterMode | The register's MagFilterMode field.
  [out] | accelFilterMode | The register's AccelFilterMode field.
  [out] | gyroFilterMode | The register's GyroFilterMode field.
  [out] | tempFilterMode | The register's TempFilterMode field.
  [out] | presFilterMode | The register's PresFilterMode field.

void vn::protocol::uart::Packet::parseImuMeasurements | ( | vn::math::vec3f * | mag,
|  | vn::math::vec3f * | accel,
|  | vn::math::vec3f * | gyro,
|  | float * | temp,
|  | float * | pressure
| ) |  |

Parses a response from reading the IMU Measurements register.

Parameters

  [out] | mag | The register's Mag field.
  [out] | accel | The register's Accel field.
  [out] | gyro | The register's Gyro field.
  [out] | temp | The register's Temp field.
  [out] | pressure | The register's Pressure field.

void vn::protocol::uart::Packet::parseImuRateConfiguration | ( | uint16_t * | imuRate,
|  | uint16_t * | navDivisor,
|  | float * | filterTargetRate,
|  | float * | filterMinRate
| ) |  |

Parses a response from reading the IMU Rate Configuration register.

Parameters

  [out] | imuRate | The register's imuRate field.
  [out] | navDivisor | The register's NavDivisor field.
  [out] | filterTargetRate | The register's filterTargetRate field.
  [out] | filterMinRate | The register's filterMinRate field.

void vn::protocol::uart::Packet::parseIndoorHeadingModeControl | ( | float * | maxRateError | ) |

Parses a response from reading the Indoor Heading Mode Control register.

Parameters

  [out] | maxRateError | The register's Max Rate Error field.

void vn::protocol::uart::Packet::parseInsAdvancedConfiguration | ( | uint8_t * | useMag,
|  | uint8_t * | usePres,
|  | uint8_t * | posAtt,
|  | uint8_t * | velAtt,
|  | uint8_t * | velBias,
|  | uint8_t * | useFoam,
|  | uint8_t * | gpsCovType,
|  | uint8_t * | velCount,
|  | float * | velInit,
|  | float * | moveOrigin,
|  | float * | gpsTimeout,
|  | float * | deltaLimitPos,
|  | float * | deltaLimitVel,
|  | float * | minPosUncertainty,
|  | float * | minVelUncertainty
| ) |  |

Parses a response from reading the INS Advanced Configuration register.

Parameters

  [out] | useMag | The register's UseMag field.
  [out] | usePres | The register's UsePres field.
  [out] | posAtt | The register's PosAtt field.
  [out] | velAtt | The register's VelAtt field.
  [out] | velBias | The register's VelBias field.
  [out] | useFoam | The register's UseFoam field.
  [out] | gpsCovType | The register's GPSCovType field.
  [out] | velCount | The register's VelCount field.
  [out] | velInit | The register's VelInit field.
  [out] | moveOrigin | The register's MoveOrigin field.
  [out] | gpsTimeout | The register's GPSTimeout field.
  [out] | deltaLimitPos | The register's DeltaLimitPos field.
  [out] | deltaLimitVel | The register's DeltaLimitVel field.
  [out] | minPosUncertainty | The register's MinPosUncertainty field.
  [out] | minVelUncertainty | The register's MinVelUncertainty field.

void vn::protocol::uart::Packet::parseInsBasicConfiguration | ( | uint8_t * | scenario,
|  | uint8_t * | ahrsAiding
| ) |  |

Parses a response from reading the INS Basic Configuration register.

Parameters

  [out] | scenario | The register's Scenario field.
  [out] | ahrsAiding | The register's AhrsAiding field.

void vn::protocol::uart::Packet::parseInsBasicConfiguration | ( | uint8_t * | scenario,
|  | uint8_t * | ahrsAiding,
|  | uint8_t * | estBaseline
| ) |  |

Parses a response from reading the INS Basic Configuration register.

Parameters

  [out] | scenario | The register's Scenario field.
  [out] | ahrsAiding | The register's AhrsAiding field.
  [out] | estBaseline | The register's EstBaseline field.

void vn::protocol::uart::Packet::parseInsSolutionEcef | ( | double * | time,
|  | uint16_t * | week,
|  | uint16_t * | status,
|  | vn::math::vec3f * | yawPitchRoll,
|  | vn::math::vec3d * | position,
|  | vn::math::vec3f * | velocity,
|  | float * | attUncertainty,
|  | float * | posUncertainty,
|  | float * | velUncertainty
| ) |  |

Parses a response from reading the INS Solution - ECEF register.

Parameters

  [out] | time | The register's Time field.
  [out] | week | The register's Week field.
  [out] | status | The register's Status field.
  [out] | yawPitchRoll | The register's YawPitchRoll field.
  [out] | position | The register's Position field.
  [out] | velocity | The register's Velocity field.
  [out] | attUncertainty | The register's AttUncertainty field.
  [out] | posUncertainty | The register's PosUncertainty field.
  [out] | velUncertainty | The register's VelUncertainty field.

void vn::protocol::uart::Packet::parseInsSolutionLla | ( | double * | time,
|  | uint16_t * | week,
|  | uint16_t * | status,
|  | vn::math::vec3f * | yawPitchRoll,
|  | vn::math::vec3d * | position,
|  | vn::math::vec3f * | nedVel,
|  | float * | attUncertainty,
|  | float * | posUncertainty,
|  | float * | velUncertainty
| ) |  |

Parses a response from reading the INS Solution - LLA register.

Parameters

  [out] | time | The register's Time field.
  [out] | week | The register's Week field.
  [out] | status | The register's Status field.
  [out] | yawPitchRoll | The register's YawPitchRoll field.
  [out] | position | The register's Position field.
  [out] | nedVel | The register's NedVel field.
  [out] | attUncertainty | The register's AttUncertainty field.
  [out] | posUncertainty | The register's PosUncertainty field.
  [out] | velUncertainty | The register's VelUncertainty field.

void vn::protocol::uart::Packet::parseInsStateEcef | ( | vn::math::vec3f * | yawPitchRoll,
|  | vn::math::vec3d * | position,
|  | vn::math::vec3f * | velocity,
|  | vn::math::vec3f * | accel,
|  | vn::math::vec3f * | angularRate
| ) |  |

Parses a response from reading the INS State - ECEF register.

Parameters

  [out] | yawPitchRoll | The register's YawPitchRoll field.
  [out] | position | The register's Position field.
  [out] | velocity | The register's Velocity field.
  [out] | accel | The register's Accel field.
  [out] | angularRate | The register's AngularRate field.

void vn::protocol::uart::Packet::parseInsStateLla | ( | vn::math::vec3f * | yawPitchRoll,
|  | vn::math::vec3d * | position,
|  | vn::math::vec3f * | velocity,
|  | vn::math::vec3f * | accel,
|  | vn::math::vec3f * | angularRate
| ) |  |

Parses a response from reading the INS State - LLA register.

Parameters

  [out] | yawPitchRoll | The register's YawPitchRoll field.
  [out] | position | The register's Position field.
  [out] | velocity | The register's Velocity field.
  [out] | accel | The register's Accel field.
  [out] | angularRate | The register's AngularRate field.

void vn::protocol::uart::Packet::parseMagneticAccelerationAndAngularRates | ( | vn::math::vec3f * | mag,
|  | vn::math::vec3f * | accel,
|  | vn::math::vec3f * | gyro
| ) |  |

Parses a response from reading the Magnetic, Acceleration and Angular Rates register.

Parameters

  [out] | mag | The register's Mag field.
  [out] | accel | The register's Accel field.
  [out] | gyro | The register's Gyro field.

void vn::protocol::uart::Packet::parseMagneticAndGravityReferenceVectors | ( | vn::math::vec3f * | magRef,
|  | vn::math::vec3f * | accRef
| ) |  |

Parses a response from reading the Magnetic and Gravity Reference Vectors register.

Parameters

  [out] | magRef | The register's MagRef field.
  [out] | accRef | The register's AccRef field.

void vn::protocol::uart::Packet::parseMagneticMeasurements | ( | vn::math::vec3f * | mag | ) |

Parses a response from reading the Magnetic Measurements register.

Parameters

  [out] | mag | The register's Mag field.

void vn::protocol::uart::Packet::parseMagnetometerCalibrationControl | ( | uint8_t * | hsiMode,
|  | uint8_t * | hsiOutput,
|  | uint8_t * | convergeRate
| ) |  |

Parses a response from reading the Magnetometer Calibration Control register.

Parameters

  [out] | hsiMode | The register's HSIMode field.
  [out] | hsiOutput | The register's HSIOutput field.
  [out] | convergeRate | The register's ConvergeRate field.

void vn::protocol::uart::Packet::parseMagnetometerCompensation | ( | vn::math::mat3f * | c,
|  | vn::math::vec3f * | b
| ) |  |

Parses a response from reading the Magnetometer Compensation register.

Parameters

  [out] | c | The register's C field.
  [out] | b | The register's B field.

void vn::protocol::uart::Packet::parseModelNumber | ( | char * | productName | ) |

Parses a response from reading the Model Number register.

Parameters

  [out] | productName | The register's Product Name field.

Examples:
  uart_protocol/main.cpp.

void vn::protocol::uart::Packet::parseQuaternionMagneticAccelerationAndAngularRates | ( | vn::math::vec4f * | quat,
|  | vn::math::vec3f * | mag,
|  | vn::math::vec3f * | accel,
|  | vn::math::vec3f * | gyro
| ) |  |

Parses a response from reading the Quaternion, Magnetic, Acceleration and Angular Rates register.

Parameters

  [out] | quat | The register's Quat field.
  [out] | mag | The register's Mag field.
  [out] | accel | The register's Accel field.
  [out] | gyro | The register's Gyro field.

void vn::protocol::uart::Packet::parseReferenceFrameRotation | ( | vn::math::mat3f * | c | ) |

Parses a response from reading the Reference Frame Rotation register.

Parameters

  [out] | c | The register's C field.

void vn::protocol::uart::Packet::parseReferenceVectorConfiguration | ( | uint8_t * | useMagModel,
|  | uint8_t * | useGravityModel,
|  | uint32_t * | recalcThreshold,
|  | float * | year,
|  | vn::math::vec3d * | position
| ) |  |

Parses a response from reading the Reference Vector Configuration register.

Parameters

  [out] | useMagModel | The register's UseMagModel field.
  [out] | useGravityModel | The register's UseGravityModel field.
  [out] | recalcThreshold | The register's RecalcThreshold field.
  [out] | year | The register's Year field.
  [out] | position | The register's Position field.

void vn::protocol::uart::Packet::parseSerialBaudRate | ( | uint32_t * | baudrate | ) |

Parses a response from reading the Serial Baud Rate register.

Parameters

  [out] | baudrate | The register's Baud Rate field.

void vn::protocol::uart::Packet::parseSerialNumber | ( | uint32_t * | serialNum | ) |

Parses a response from reading the Serial Number register.

Parameters

  [out] | serialNum | The register's SerialNum field.

void vn::protocol::uart::Packet::parseStartupFilterBiasEstimate | ( | vn::math::vec3f * | gyroBias,
|  | vn::math::vec3f * | accelBias,
|  | float * | pressureBias
| ) |  |

Parses a response from reading the Startup Filter Bias Estimate register.

Parameters

  [out] | gyroBias | The register's GyroBias field.
  [out] | accelBias | The register's AccelBias field.
  [out] | pressureBias | The register's PressureBias field.

void vn::protocol::uart::Packet::parseSynchronizationControl | ( | uint8_t * | syncInMode,
|  | uint8_t * | syncInEdge,
|  | uint16_t * | syncInSkipFactor,
|  | uint8_t * | syncOutMode,
|  | uint8_t * | syncOutPolarity,
|  | uint16_t * | syncOutSkipFactor,
|  | uint32_t * | syncOutPulseWidth
| ) |  |

Parses a response from reading the Synchronization Control register.

Parameters

  [out] | syncInMode | The register's SyncInMode field.
  [out] | syncInEdge | The register's SyncInEdge field.
  [out] | syncInSkipFactor | The register's SyncInSkipFactor field.
  [out] | syncOutMode | The register's SyncOutMode field.
  [out] | syncOutPolarity | The register's SyncOutPolarity field.
  [out] | syncOutSkipFactor | The register's SyncOutSkipFactor field.
  [out] | syncOutPulseWidth | The register's SyncOutPulseWidth field.

void vn::protocol::uart::Packet::parseSynchronizationStatus | ( | uint32_t * | syncInCount,
|  | uint32_t * | syncInTime,
|  | uint32_t * | syncOutCount
| ) |  |

Parses a response from reading the Synchronization Status register.

Parameters

  [out] | syncInCount | The register's SyncInCount field.
  [out] | syncInTime | The register's SyncInTime field.
  [out] | syncOutCount | The register's SyncOutCount field.

void vn::protocol::uart::Packet::parseUserTag | ( | char * | tag | ) |

Parses a response from reading the User Tag register.

Parameters

  [out] | tag | The register's Tag field.

void vn::protocol::uart::Packet::parseVelocityCompensationControl | ( | uint8_t * | mode,
|  | float * | velocityTuning,
|  | float * | rateTuning
| ) |  |

Parses a response from reading the Velocity Compensation Control register.

Parameters

  [out] | mode | The register's Mode field.
  [out] | velocityTuning | The register's VelocityTuning field.
  [out] | rateTuning | The register's RateTuning field.

void vn::protocol::uart::Packet::parseVelocityCompensationMeasurement | ( | vn::math::vec3f * | velocity | ) |

Parses a response from reading the Velocity Compensation Measurement register.

Parameters

  [out] | velocity | The register's Velocity field.

void vn::protocol::uart::Packet::parseVelocityCompensationStatus | ( | float * | x,
|  | float * | xDot,
|  | vn::math::vec3f * | accelOffset,
|  | vn::math::vec3f * | omega
| ) |  |

Parses a response from reading the Velocity Compensation Status register.

Parameters

  [out] | x | The register's x field.
  [out] | xDot | The register's xDot field.
  [out] | accelOffset | The register's accelOffset field.
  [out] | omega | The register's omega field.

void vn::protocol::uart::Packet::parseVpeAccelerometerAdvancedTuning | ( | vn::math::vec3f * | minFiltering,
|  | vn::math::vec3f * | maxFiltering,
|  | float * | maxAdaptRate,
|  | float * | disturbanceWindow,
|  | float * | maxTuning
| ) |  |

Parses a response from reading the VPE Accelerometer Advanced Tuning register.

Parameters

  [out] | minFiltering | The register's MinFiltering field.
  [out] | maxFiltering | The register's MaxFiltering field.
  [out] | maxAdaptRate | The register's MaxAdaptRate field.
  [out] | disturbanceWindow | The register's DisturbanceWindow field.
  [out] | maxTuning | The register's MaxTuning field.

void vn::protocol::uart::Packet::parseVpeAccelerometerBasicTuning | ( | vn::math::vec3f * | baseTuning,
|  | vn::math::vec3f * | adaptiveTuning,
|  | vn::math::vec3f * | adaptiveFiltering
| ) |  |

Parses a response from reading the VPE Accelerometer Basic Tuning register.

Parameters

  [out] | baseTuning | The register's BaseTuning field.
  [out] | adaptiveTuning | The register's AdaptiveTuning field.
  [out] | adaptiveFiltering | The register's AdaptiveFiltering field.

void vn::protocol::uart::Packet::parseVpeBasicControl | ( | uint8_t * | enable,
|  | uint8_t * | headingMode,
|  | uint8_t * | filteringMode,
|  | uint8_t * | tuningMode
| ) |  |

Parses a response from reading the VPE Basic Control register.

Parameters

  [out] | enable | The register's Enable field.
  [out] | headingMode | The register's HeadingMode field.
  [out] | filteringMode | The register's FilteringMode field.
  [out] | tuningMode | The register's TuningMode field.

Examples:
  uart_protocol/main.cpp.

void vn::protocol::uart::Packet::parseVpeGyroBasicTuning | ( | vn::math::vec3f * | angularWalkVariance,
|  | vn::math::vec3f * | baseTuning,
|  | vn::math::vec3f * | adaptiveTuning
| ) |  |

Parses a response from reading the VPE Gyro Basic Tuning register.

Parameters

  [out] | angularWalkVariance | The register's AngularWalkVariance field.
  [out] | baseTuning | The register's BaseTuning field.
  [out] | adaptiveTuning | The register's AdaptiveTuning field.

void vn::protocol::uart::Packet::parseVpeMagnetometerAdvancedTuning | ( | vn::math::vec3f * | minFiltering,
|  | vn::math::vec3f * | maxFiltering,
|  | float * | maxAdaptRate,
|  | float * | disturbanceWindow,
|  | float * | maxTuning
| ) |  |

Parses a response from reading the VPE Magnetometer Advanced Tuning register.

Parameters

  [out] | minFiltering | The register's MinFiltering field.
  [out] | maxFiltering | The register's MaxFiltering field.
  [out] | maxAdaptRate | The register's MaxAdaptRate field.
  [out] | disturbanceWindow | The register's DisturbanceWindow field.
  [out] | maxTuning | The register's MaxTuning field.

void vn::protocol::uart::Packet::parseVpeMagnetometerBasicTuning | ( | vn::math::vec3f * | baseTuning,
|  | vn::math::vec3f * | adaptiveTuning,
|  | vn::math::vec3f * | adaptiveFiltering
| ) |  |

Parses a response from reading the VPE Magnetometer Basic Tuning register.

Parameters

  [out] | baseTuning | The register's BaseTuning field.
  [out] | adaptiveTuning | The register's AdaptiveTuning field.
  [out] | adaptiveFiltering | The register's AdaptiveFiltering field.

void vn::protocol::uart::Packet::parseYawPitchRoll | ( | vn::math::vec3f * | yawPitchRoll | ) |

Parses a response from reading the Yaw Pitch Roll register.

Parameters

  [out] | yawPitchRoll | The register's YawPitchRoll field.

void vn::protocol::uart::Packet::parseYawPitchRollMagneticAccelerationAndAngularRates | ( | vn::math::vec3f * | yawPitchRoll,
|  | vn::math::vec3f * | mag,
|  | vn::math::vec3f * | accel,
|  | vn::math::vec3f * | gyro
| ) |  |

Parses a response from reading the Yaw, Pitch, Roll, Magnetic, Acceleration and Angular Rates register.

Parameters

  [out] | yawPitchRoll | The register's YawPitchRoll field.
  [out] | mag | The register's Mag field.
  [out] | accel | The register's Accel field.
  [out] | gyro | The register's Gyro field.

void vn::protocol::uart::Packet::parseYawPitchRollTrueBodyAccelerationAndAngularRates | ( | vn::math::vec3f * | yawPitchRoll,
|  | vn::math::vec3f * | bodyAccel,
|  | vn::math::vec3f * | gyro
| ) |  |

Parses a response from reading the Yaw, Pitch, Roll, True Body Acceleration and Angular Rates register.

Parameters

  [out] | yawPitchRoll | The register's YawPitchRoll field.
  [out] | bodyAccel | The register's BodyAccel field.
  [out] | gyro | The register's Gyro field.

void vn::protocol::uart::Packet::parseYawPitchRollTrueInertialAccelerationAndAngularRates | ( | vn::math::vec3f * | yawPitchRoll,
|  | vn::math::vec3f * | inertialAccel,
|  | vn::math::vec3f * | gyro
| ) |  |

Parses a response from reading the Yaw, Pitch, Roll, True Inertial Acceleration and Angular Rates register.

Parameters

  [out] | yawPitchRoll | The register's YawPitchRoll field.
  [out] | inertialAccel | The register's InertialAccel field.
  [out] | gyro | The register's Gyro field.